import { StorageEngine } from '../../storage';
import { AnyData, AnyObject, ObjectOf } from '../../core/type/data';
import { CacheInterface } from '../interface/index';
import { CacheConfiguration } from '../type';
declare class Cache implements CacheInterface<Cache> {
    protected storeName: string;
    protected configs: CacheConfiguration;
    protected storage: StorageEngine;
    protected store: AnyObject;
    protected stores: ObjectOf<Cache>;
    protected list: string[];
    constructor(configs?: CacheConfiguration);
    readonly length: number;
    useStore(storeName: string): Cache;
    get(key: string, defaultValue?: AnyData): AnyData;
    set(key: string, value: AnyData, time?: number): Promise<AnyData>;
    remove(key: string): Promise<AnyData>;
    clear(): Promise<AnyObject>;
    keys(): string[];
    all(): AnyObject;
    merge(object: AnyObject): AnyObject;
    restore(): Promise<void>;
    protected getListKeyName(): string;
    protected getItemKeyName(key: string): string;
}
export default Cache;
