export declare type AnyData = any;
export interface AnyObject {
    [key: string]: any;
}
export declare type AnyBoolean = boolean;
export declare type AnyArray = any[];
export declare type Nilable = null | undefined;
export declare type NilableArray = any[] | undefined | null;
export declare type NilableBoolean = Nilable | AnyBoolean;
export declare type NilableObject = Nilable | AnyObject;
export declare type Nullable = null;
export declare type NullableArray = any[] | null;
export declare type NullableBoolean = boolean | Nullable;
export declare type NullableObject = AnyObject | Nullable;
export declare type Undefinable = undefined;
export declare type UndefinableBoolean = boolean | Undefinable;
export declare type UndefinableObject = AnyObject | Undefinable;
export declare type FunctionObject = {
    [key: string]: Function;
};
export declare type FunctionArray = Function[];
export interface ObjectOf<T> {
    [key: string]: T;
}
export declare type NilableObjectOf<T> = ObjectOf<T> | undefined | null;
