"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
class DataAdaptor {
    constructor(structure) {
        this.structure = structure;
    }
    parse(origin, structure = this.structure) {
        const result = {};
        for (const key in structure) {
            const value = structure[key];
            if (_.isObject(value)) {
                result[key] = this.parse(origin, value);
                continue;
            }
            if (value.includes('[')) {
                result[key] = _.get(origin, value);
                continue;
            }
            if (value.includes('.')) {
                let resultValue = origin;
                const arrayedPath = value.split('.');
                for (const path of arrayedPath) {
                    resultValue = resultValue[path];
                    if (!resultValue) {
                        break;
                    }
                }
                result[key] = resultValue;
                continue;
            }
            result[key] = origin[key];
        }
        return result;
    }
}
exports.default = DataAdaptor;
//# sourceMappingURL=DataAdaptor.js.map