"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
describe('DataAdaptor', () => {
    test('.parse', () => {
        const origin1 = { a: 1, b: 2, c: { d: 3 } };
        const t1 = new index_1.DataAdaptor({ a: 'a', b: 'b', d: 'c.d' })
            .parse(origin1);
        const e1 = { a: 1, b: 2, d: 3 };
        expect(t1).toEqual(e1);
        const origin2 = { a: 1, b: 2, c: { d: 3 } };
        const t2 = new index_1.DataAdaptor({ a: { a: 'a', b: 'b' }, c: { f: 'c.d' } })
            .parse(origin2);
        const e2 = { a: { a: 1, b: 2 }, c: { f: 3 } };
        expect(t2).toEqual(e2);
        const date = new Date();
        const origin3 = { a: 1, b: 2, c: { d: date } };
        const t3 = new index_1.DataAdaptor({ a: { a: 'a', b: 'b' }, c: { f: 'c.d' } })
            .parse(origin3);
        const e3 = { a: { a: 1, b: 2 }, c: { f: date } };
        expect(t3).toEqual(e3);
    });
});
//# sourceMappingURL=DataAdaptor.js.map