"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function HOF(target, propertyName) {
    const oldFunction = target[propertyName];
    return {
        enumerable: true,
        configurable: true,
        get() {
            return function (...args) {
                return oldFunction.bind(this, ...args);
            };
        },
        set(value) {
            this[propertyName] = value;
        },
    };
}
exports.default = HOF;
//# sourceMappingURL=HOF.js.map