"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const event_1 = require("../event");
const Listen = (eventName) => {
    return (target, propertyKey) => {
        const originalCDM = target['componentDidMount'];
        const originalCWU = target['componentWillUnmount'];
        const eventCallback = target[propertyKey];
        target['componentDidMount'] = () => {
            originalCDM && originalCDM();
            event_1.Event.on(eventName, eventCallback);
        };
        target['componentWillUnmount'] = () => {
            originalCWU && originalCWU();
            event_1.Event.remove(eventName, eventCallback);
        };
        return target;
    };
};
exports.default = Listen;
//# sourceMappingURL=Listen.js.map