"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const EventEmitter = require("wolfy87-eventemitter");
class EventEngine {
    constructor() {
        this.store = new EventEmitter();
        this.on = (event, callback) => {
            this.store.on(event, callback);
            return this;
        };
        this.once = (event, callback) => {
            this.store.once(event, callback);
            return this;
        };
        this.emit = (event, ...args) => {
            this.store.emit(event, args);
            return this;
        };
        this.remove = (event, callback) => {
            this.store.removeListener(event, callback);
            return this;
        };
        this.clear = () => {
            this.store.removeAllListeners();
            return this;
        };
        this.get = (event) => {
            return this.store.getListeners(event);
        };
        this.all = () => {
            return this.get(/./);
        };
    }
    load(events) {
        this.store.addListeners(events);
        return this;
    }
}
exports.default = EventEngine;
//# sourceMappingURL=EventEngine.js.map