import HttpAbortException from './HttpAbortException';
import HttpBadRequestException from './HttpBadRequestException';
import HttpUnauthorizedException from './HttpUnauthorizedException';
import HttpPaymentRequiredException from './HttpPaymentRequiredException';
import HttpForbiddenException from './HttpForbiddenException';
import HttpNotFoundException from './HttpNotFoundException';
import HttpMethodNotAllowedException from './HttpMethodNotAllowedException';
import HttpNotAcceptableException from './HttpNotAcceptableException';
import HttpProxyAuthenticationException from './HttpProxyAuthenticationRequiredException';
import HttpRequestTimeoutException from './HttpRequestTimeoutException';
import HttpConflictException from './HttpConflictException';
import HttpGoneException from './HttpGoneException';
import HttpLengthRequiredException from './HttpLengthRequiredException';
import HttpPreconditionFailedException from './HttpPreconditionFailedException';
import HttpPayloadTooLargeException from './HttpPayloadTooLargeException';
import HttpURITooLongException from './HttpURITooLongException';
import HttpUnsupportedMediaTypeException from './HttpUnsupportedMediaTypeException';
import HttpRangeNotSatisfiableException from './HttpRangeNotSatisfiableException';
import HttpExpectationFailedException from './HttpExpectationFailedException';
import HttpMisdirectedRequestException from './HttpMisdirectedRequestException';
import HttpUnprocessableEntityException from './HttpUnprocessableEntityException';
import HttpLockedException from './HttpLockedException';
import HttpFailedDependencyException from './HttpFailedDependencyException';
import HttpUpgradeRequiredException from './HttpUpgradeRequiredException';
import HttpPreconditionRequiredException from './HttpPreconditionRequiredException';
import HttpTooManyRequestsException from './HttpTooManyRequestsExceptions';
import HttpRequestHeaderFieldsTooLargeException from './HttpRequestHeaderFieldsTooLargeException';
import HttpUnavailableForLegalReasonsException from './HttpUnavailableForLegalReasonsException';
import HttpInternalServerErrorException from './HttpInternalServerErrorException';
import HttpNotImplementedException from './HttpNotImplementedException';
import HttpBadGatewayException from './HttpBadGatewayException';
import HttpServiceUnavailableException from './HttpServiceUnavailableException';
import HttpGatewayTimeoutException from './HttpGatewayTimeoutException';
import HttpVersionNotSupportedException from './HttpVersionNotSupportedException';
import HttpVariantAlsoNegotiatesException from './HttpVariantAlsoNegotiatesException';
import HttpInsufficientStorageException from './HttpInsufficientStorageException';
import HttpLoopDetectedException from './HttpLoopDetectedException';
import HttpNotExtendedException from './HttpNotExtendedException';
import HttpNetworkAuthenticationRequiredException from './HttpNetworkAuthenticationRequiredException';
declare const CodedHttpExceptions: {
    400: typeof HttpBadRequestException;
    401: typeof HttpUnauthorizedException;
    402: typeof HttpPaymentRequiredException;
    403: typeof HttpForbiddenException;
    404: typeof HttpNotFoundException;
    405: typeof HttpMethodNotAllowedException;
    406: typeof HttpNotAcceptableException;
    407: typeof HttpProxyAuthenticationException;
    408: typeof HttpRequestTimeoutException;
    409: typeof HttpConflictException;
    410: typeof HttpGoneException;
    411: typeof HttpLengthRequiredException;
    412: typeof HttpPreconditionFailedException;
    413: typeof HttpPayloadTooLargeException;
    414: typeof HttpURITooLongException;
    415: typeof HttpUnsupportedMediaTypeException;
    416: typeof HttpRangeNotSatisfiableException;
    417: typeof HttpExpectationFailedException;
    421: typeof HttpMisdirectedRequestException;
    422: typeof HttpUnprocessableEntityException;
    423: typeof HttpLockedException;
    424: typeof HttpFailedDependencyException;
    426: typeof HttpUpgradeRequiredException;
    428: typeof HttpPreconditionRequiredException;
    429: typeof HttpTooManyRequestsException;
    431: typeof HttpRequestHeaderFieldsTooLargeException;
    451: typeof HttpUnavailableForLegalReasonsException;
    500: typeof HttpInternalServerErrorException;
    501: typeof HttpNotImplementedException;
    502: typeof HttpBadGatewayException;
    503: typeof HttpServiceUnavailableException;
    504: typeof HttpGatewayTimeoutException;
    505: typeof HttpVersionNotSupportedException;
    506: typeof HttpVariantAlsoNegotiatesException;
    507: typeof HttpInsufficientStorageException;
    508: typeof HttpLoopDetectedException;
    510: typeof HttpNotExtendedException;
    511: typeof HttpNetworkAuthenticationRequiredException;
};
export { CodedHttpExceptions, HttpAbortException, HttpBadRequestException, HttpUnauthorizedException, HttpPaymentRequiredException, HttpForbiddenException, HttpNotFoundException, HttpMethodNotAllowedException, HttpNotAcceptableException, HttpProxyAuthenticationException, HttpRequestTimeoutException, HttpConflictException, HttpGoneException, HttpLengthRequiredException, HttpPreconditionFailedException, HttpPayloadTooLargeException, HttpURITooLongException, HttpUnsupportedMediaTypeException, HttpRangeNotSatisfiableException, HttpExpectationFailedException, HttpMisdirectedRequestException, HttpUnprocessableEntityException, HttpLockedException, HttpFailedDependencyException, HttpUpgradeRequiredException, HttpPreconditionRequiredException, HttpTooManyRequestsException, HttpRequestHeaderFieldsTooLargeException, HttpUnavailableForLegalReasonsException, HttpInternalServerErrorException, HttpNotImplementedException, HttpBadGatewayException, HttpServiceUnavailableException, HttpGatewayTimeoutException, HttpVersionNotSupportedException, HttpVariantAlsoNegotiatesException, HttpInsufficientStorageException, HttpLoopDetectedException, HttpNotExtendedException, HttpNetworkAuthenticationRequiredException, };
