"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const HttpAbortException_1 = require("./HttpAbortException");
exports.HttpAbortException = HttpAbortException_1.default;
const HttpBadRequestException_1 = require("./HttpBadRequestException");
exports.HttpBadRequestException = HttpBadRequestException_1.default;
const HttpUnauthorizedException_1 = require("./HttpUnauthorizedException");
exports.HttpUnauthorizedException = HttpUnauthorizedException_1.default;
const HttpPaymentRequiredException_1 = require("./HttpPaymentRequiredException");
exports.HttpPaymentRequiredException = HttpPaymentRequiredException_1.default;
const HttpForbiddenException_1 = require("./HttpForbiddenException");
exports.HttpForbiddenException = HttpForbiddenException_1.default;
const HttpNotFoundException_1 = require("./HttpNotFoundException");
exports.HttpNotFoundException = HttpNotFoundException_1.default;
const HttpMethodNotAllowedException_1 = require("./HttpMethodNotAllowedException");
exports.HttpMethodNotAllowedException = HttpMethodNotAllowedException_1.default;
const HttpNotAcceptableException_1 = require("./HttpNotAcceptableException");
exports.HttpNotAcceptableException = HttpNotAcceptableException_1.default;
const HttpProxyAuthenticationRequiredException_1 = require("./HttpProxyAuthenticationRequiredException");
exports.HttpProxyAuthenticationException = HttpProxyAuthenticationRequiredException_1.default;
const HttpRequestTimeoutException_1 = require("./HttpRequestTimeoutException");
exports.HttpRequestTimeoutException = HttpRequestTimeoutException_1.default;
const HttpConflictException_1 = require("./HttpConflictException");
exports.HttpConflictException = HttpConflictException_1.default;
const HttpGoneException_1 = require("./HttpGoneException");
exports.HttpGoneException = HttpGoneException_1.default;
const HttpLengthRequiredException_1 = require("./HttpLengthRequiredException");
exports.HttpLengthRequiredException = HttpLengthRequiredException_1.default;
const HttpPreconditionFailedException_1 = require("./HttpPreconditionFailedException");
exports.HttpPreconditionFailedException = HttpPreconditionFailedException_1.default;
const HttpPayloadTooLargeException_1 = require("./HttpPayloadTooLargeException");
exports.HttpPayloadTooLargeException = HttpPayloadTooLargeException_1.default;
const HttpURITooLongException_1 = require("./HttpURITooLongException");
exports.HttpURITooLongException = HttpURITooLongException_1.default;
const HttpUnsupportedMediaTypeException_1 = require("./HttpUnsupportedMediaTypeException");
exports.HttpUnsupportedMediaTypeException = HttpUnsupportedMediaTypeException_1.default;
const HttpRangeNotSatisfiableException_1 = require("./HttpRangeNotSatisfiableException");
exports.HttpRangeNotSatisfiableException = HttpRangeNotSatisfiableException_1.default;
const HttpExpectationFailedException_1 = require("./HttpExpectationFailedException");
exports.HttpExpectationFailedException = HttpExpectationFailedException_1.default;
const HttpMisdirectedRequestException_1 = require("./HttpMisdirectedRequestException");
exports.HttpMisdirectedRequestException = HttpMisdirectedRequestException_1.default;
const HttpUnprocessableEntityException_1 = require("./HttpUnprocessableEntityException");
exports.HttpUnprocessableEntityException = HttpUnprocessableEntityException_1.default;
const HttpLockedException_1 = require("./HttpLockedException");
exports.HttpLockedException = HttpLockedException_1.default;
const HttpFailedDependencyException_1 = require("./HttpFailedDependencyException");
exports.HttpFailedDependencyException = HttpFailedDependencyException_1.default;
const HttpUpgradeRequiredException_1 = require("./HttpUpgradeRequiredException");
exports.HttpUpgradeRequiredException = HttpUpgradeRequiredException_1.default;
const HttpPreconditionRequiredException_1 = require("./HttpPreconditionRequiredException");
exports.HttpPreconditionRequiredException = HttpPreconditionRequiredException_1.default;
const HttpTooManyRequestsExceptions_1 = require("./HttpTooManyRequestsExceptions");
exports.HttpTooManyRequestsException = HttpTooManyRequestsExceptions_1.default;
const HttpRequestHeaderFieldsTooLargeException_1 = require("./HttpRequestHeaderFieldsTooLargeException");
exports.HttpRequestHeaderFieldsTooLargeException = HttpRequestHeaderFieldsTooLargeException_1.default;
const HttpUnavailableForLegalReasonsException_1 = require("./HttpUnavailableForLegalReasonsException");
exports.HttpUnavailableForLegalReasonsException = HttpUnavailableForLegalReasonsException_1.default;
const HttpInternalServerErrorException_1 = require("./HttpInternalServerErrorException");
exports.HttpInternalServerErrorException = HttpInternalServerErrorException_1.default;
const HttpNotImplementedException_1 = require("./HttpNotImplementedException");
exports.HttpNotImplementedException = HttpNotImplementedException_1.default;
const HttpBadGatewayException_1 = require("./HttpBadGatewayException");
exports.HttpBadGatewayException = HttpBadGatewayException_1.default;
const HttpServiceUnavailableException_1 = require("./HttpServiceUnavailableException");
exports.HttpServiceUnavailableException = HttpServiceUnavailableException_1.default;
const HttpGatewayTimeoutException_1 = require("./HttpGatewayTimeoutException");
exports.HttpGatewayTimeoutException = HttpGatewayTimeoutException_1.default;
const HttpVersionNotSupportedException_1 = require("./HttpVersionNotSupportedException");
exports.HttpVersionNotSupportedException = HttpVersionNotSupportedException_1.default;
const HttpVariantAlsoNegotiatesException_1 = require("./HttpVariantAlsoNegotiatesException");
exports.HttpVariantAlsoNegotiatesException = HttpVariantAlsoNegotiatesException_1.default;
const HttpInsufficientStorageException_1 = require("./HttpInsufficientStorageException");
exports.HttpInsufficientStorageException = HttpInsufficientStorageException_1.default;
const HttpLoopDetectedException_1 = require("./HttpLoopDetectedException");
exports.HttpLoopDetectedException = HttpLoopDetectedException_1.default;
const HttpNotExtendedException_1 = require("./HttpNotExtendedException");
exports.HttpNotExtendedException = HttpNotExtendedException_1.default;
const HttpNetworkAuthenticationRequiredException_1 = require("./HttpNetworkAuthenticationRequiredException");
exports.HttpNetworkAuthenticationRequiredException = HttpNetworkAuthenticationRequiredException_1.default;
const CodedHttpExceptions = {
    400: HttpBadRequestException_1.default,
    401: HttpUnauthorizedException_1.default,
    402: HttpPaymentRequiredException_1.default,
    403: HttpForbiddenException_1.default,
    404: HttpNotFoundException_1.default,
    405: HttpMethodNotAllowedException_1.default,
    406: HttpNotAcceptableException_1.default,
    407: HttpProxyAuthenticationRequiredException_1.default,
    408: HttpRequestTimeoutException_1.default,
    409: HttpConflictException_1.default,
    410: HttpGoneException_1.default,
    411: HttpLengthRequiredException_1.default,
    412: HttpPreconditionFailedException_1.default,
    413: HttpPayloadTooLargeException_1.default,
    414: HttpURITooLongException_1.default,
    415: HttpUnsupportedMediaTypeException_1.default,
    416: HttpRangeNotSatisfiableException_1.default,
    417: HttpExpectationFailedException_1.default,
    421: HttpMisdirectedRequestException_1.default,
    422: HttpUnprocessableEntityException_1.default,
    423: HttpLockedException_1.default,
    424: HttpFailedDependencyException_1.default,
    426: HttpUpgradeRequiredException_1.default,
    428: HttpPreconditionRequiredException_1.default,
    429: HttpTooManyRequestsExceptions_1.default,
    431: HttpRequestHeaderFieldsTooLargeException_1.default,
    451: HttpUnavailableForLegalReasonsException_1.default,
    500: HttpInternalServerErrorException_1.default,
    501: HttpNotImplementedException_1.default,
    502: HttpBadGatewayException_1.default,
    503: HttpServiceUnavailableException_1.default,
    504: HttpGatewayTimeoutException_1.default,
    505: HttpVersionNotSupportedException_1.default,
    506: HttpVariantAlsoNegotiatesException_1.default,
    507: HttpInsufficientStorageException_1.default,
    508: HttpLoopDetectedException_1.default,
    510: HttpNotExtendedException_1.default,
    511: HttpNetworkAuthenticationRequiredException_1.default,
};
exports.CodedHttpExceptions = CodedHttpExceptions;
//# sourceMappingURL=index.js.map