"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const faker = require("faker");
class Factory {
    constructor() {
        this.callbacks = {};
        this.counts = {};
        this.wrappers = {};
    }
    define(identifier, callback, count, wrapper) {
        this.callbacks[identifier] = callback;
        this.counts[identifier] = count;
        this.wrappers[identifier] = wrapper;
    }
    has(identifier) {
        return !!this.callbacks[identifier];
    }
    make(identifier) {
        let i = 1;
        const returnValue = [];
        while (i <= this.counts[identifier]) {
            returnValue.push(this.callbacks[identifier](faker));
            i += 1;
        }
        const wrapper = this.wrappers[identifier];
        if (wrapper) {
            return wrapper(returnValue);
        }
        return returnValue;
    }
}
exports.default = Factory;
//# sourceMappingURL=Factory.js.map