"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const react_redux_1 = require("react-redux");
const Connect = (connectFunction) => {
    if (_.isFunction(connectFunction)) {
        return react_redux_1.connect(connectFunction);
    }
    return react_redux_1.connect((store) => {
        const exportData = {};
        for (const mapping of connectFunction) {
            const [pathOrName, pathOptional,] = mapping.split(':');
            let path;
            let exportName;
            if (pathOptional) {
                path = pathOptional;
                exportName = pathOrName;
            }
            else {
                path = pathOrName;
                exportName = pathOrName.split('.').pop();
            }
            exportData[exportName] = _.get(store, path);
        }
        return exportData;
    });
};
exports.default = Connect;
//# sourceMappingURL=Connect.js.map