"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FunctionCollectionDescriptorBuildUtil_1 = require("../../utility/FunctionCollectionDescriptorBuildUtil");
function DecreaseState(stateKeyOrConfig) {
    return function (target, key, descriptor) {
        if (target[key]) {
            return console.error('[Decorator]DecreaseState will override original function');
        }
        return FunctionCollectionDescriptorBuildUtil_1.default.create(target, key, descriptor, function () {
            if ('string' === typeof stateKeyOrConfig) {
                return this.setState((state) => {
                    return {
                        [stateKeyOrConfig]: state[stateKeyOrConfig] - 1,
                    };
                });
            }
            const { key, step = 1, min, } = stateKeyOrConfig;
            return this.setState((state) => {
                const currentValue = state[key];
                if (undefined !== min && currentValue < min) {
                    return {
                        [key]: min,
                    };
                }
                let newValue = state[key] - step;
                if (undefined !== min && newValue < min) {
                    newValue = min;
                }
                return {
                    [key]: newValue,
                };
            });
        });
    };
}
exports.default = DecreaseState;
//# sourceMappingURL=DecreaseState.js.map