"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FunctionCollectionDescriptorBuildUtil_1 = require("../../utility/FunctionCollectionDescriptorBuildUtil");
function SetState(stateKey, stateValue) {
    return function (target, key, descriptor) {
        if (target[key]) {
            return console.error('[Decorator]SetState will override original function');
        }
        return FunctionCollectionDescriptorBuildUtil_1.default.create(target, key, descriptor, function (...args) {
            if (undefined !== stateValue) {
                return this.setState({
                    [stateKey]: stateValue,
                });
            }
            if (Array.isArray(stateKey)) {
                const stateObject = {};
                stateKey.forEach((key, index) => {
                    stateObject[key] = args[index];
                });
                return this.setState(stateObject);
            }
            return this.setState(stateKey);
        });
    };
}
exports.default = SetState;
//# sourceMappingURL=SetState.js.map