"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FunctionCollectionDescriptorBuildUtil_1 = require("../../utility/FunctionCollectionDescriptorBuildUtil");
function DecreaseState(stateKey) {
    return function (target, key, descriptor) {
        if (target[key]) {
            return console.error('[Decorator]SetState will override original function');
        }
        return FunctionCollectionDescriptorBuildUtil_1.default.create(target, key, descriptor, function () {
            return this.setState((state) => {
                return {
                    [stateKey]: !state[stateKey],
                };
            });
        });
    };
}
exports.default = DecreaseState;
//# sourceMappingURL=ToggleState.js.map