import { AnyData, AnyObject } from '../../core/type/data';
import { RepositoryInterface } from '../Interface';
import { RepositoryConfiguration, RepositoryHooks } from '../type';
import { Interpolator } from '../../core/type/function';
declare class Repository implements RepositoryInterface {
    protected data: AnyObject;
    protected hooks: RepositoryHooks;
    protected config: any;
    constructor(config?: RepositoryConfiguration);
    readonly length: number;
    set(key: string | string[], data: AnyData, interpolator?: Interpolator): AnyData;
    get(key: string | string[], defaultValue?: AnyData, interpolator?: Interpolator): AnyData;
    public: any;
    remove(key: string | string[], interpolator?: Interpolator): AnyData;
    clear(interpolator?: Interpolator): AnyObject;
    keys(interpolator?: Interpolator): string[];
    values(interpolator?: Interpolator): AnyData[];
    all(interpolator?: Interpolator): AnyObject;
    protected multiRemove(key: string[], interpolator?: Interpolator): AnyData[];
    protected multiGet(key: string[], defaultValue: AnyData[], interpolator?: Interpolator): AnyData[];
    protected multiSet(key: string[], data: AnyData[], interpolator?: Interpolator): AnyData[];
}
export default Repository;
