"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class RepositoryLite {
    constructor() {
        this.data = {};
    }
    get length() {
        return Object.keys(this.data).length;
    }
    load(data) {
        return this.data = Object.assign({}, data);
    }
    merge(data) {
        return this.data = Object.assign({}, this.data, data);
    }
    set(key, data) {
        return this.data[key] = data;
    }
    get(key, defaultValue) {
        return this.data[key] || defaultValue;
    }
    has(key) {
        return !!this.data[key];
    }
    remove(key) {
        const data = this.data[key];
        delete this.data[key];
        return data;
    }
    clear() {
        const data = this.data;
        this.data = {};
        return data;
    }
    keys() {
        return Object.keys(this.data);
    }
    values() {
        return Object.values(this.data);
    }
    all() {
        return this.data;
    }
}
exports.default = RepositoryLite;
//# sourceMappingURL=RepositoryLite.js.map