"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
class Interceptor {
    constructor() {
        this.interceptor = {};
        this.interceptorOrder = [];
    }
    add(nameOrInterceptors, interceptor) {
        if (_.isObject(nameOrInterceptors)) {
            for (const name in nameOrInterceptors) {
                this.add(name, nameOrInterceptors[name]);
            }
            return true;
        }
        this.interceptor[nameOrInterceptors] = interceptor;
        this.interceptorOrder.push(nameOrInterceptors);
        return true;
    }
    remove(name) {
        _.unset(this.interceptor, name);
    }
    get(name) {
        return this.interceptor[name];
    }
    load(interceptors) {
        this.interceptor = interceptors;
    }
    all() {
        return this.interceptor;
    }
}
exports.default = Interceptor;
//# sourceMappingURL=Interceptor.js.map