"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Url {
    constructor(url) {
        if (typeof url === 'string') {
            this.url = url;
        }
        else {
            this.url = Url.parseUrlStringFromUrlSchema(url);
        }
    }
    static parseUrlStringFromUrlSchema(urlSchema) {
        const { domain = '', prefix = '', suffix = '', url, } = urlSchema;
        return `${domain}${prefix}${url}${suffix}`;
    }
    setUrl(url) {
        this.url = url;
    }
    toString() {
        return this.url;
    }
}
exports.default = Url;
//# sourceMappingURL=Url.js.map