"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bridge_1 = require("./bridge");
const request_1 = require("../request");
const api_1 = require("../api");
class Rua {
    constructor(configuration) {
        this.defaultConfiguration = {};
        this.configurableModules = {
            api: api_1.ApiRequest,
            request: request_1.Request,
            dva: bridge_1.RuaDva,
        };
        const configs = Object.assign({}, this.defaultConfiguration, configuration);
        for (const name in configs) {
            const module = this.configurableModules[name];
            if (!module) {
                continue;
            }
            const config = configs[name];
            const result = module.config(config);
            if (name === 'dva') {
                this.app = result;
            }
        }
    }
}
exports.default = Rua;
//# sourceMappingURL=Rua.js.map