import { StorageEngineInterface } from '../interface';
import { AnyData, AnyObject } from '../../core/type/data';
declare class StorageEngine implements StorageEngineInterface {
    readonly length: Promise<number>;
    set(key: string | string[], value: AnyData | AnyData[]): Promise<void>;
    get(key: string | string[], defaultValue?: any): Promise<AnyData>;
    remove(key: string | string[]): Promise<void>;
    clear(): Promise<void>;
    keys(): Promise<string[]>;
    values(): Promise<AnyData[]>;
    all(): Promise<AnyObject>;
}
export default StorageEngine;
