import { AnyObject, AnyData } from '../../core/type/data';
interface StorageEngineInterface {
    length: Promise<number>;
    set(key: string | string[], value: AnyData | AnyData[]): Promise<void>;
    get(key: string | string[], defaultValue?: AnyData | AnyData[]): Promise<AnyData>;
    remove(key: string | string[]): Promise<void>;
    clear(): Promise<void>;
    keys(): Promise<string[]>;
    values(): Promise<AnyData[]>;
    all(): Promise<AnyObject>;
}
export default StorageEngineInterface;
