"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FunctionCollectionUtil_1 = require("./FunctionCollectionUtil");
const descriptorTemplate = {
    enumerable: true,
    configurable: true,
};
class FunctionCollectionDescriptorBuildUtil {
    static create(target, key, descriptor, fn) {
        let fnCollection;
        const oldFn = descriptor && descriptor.get && descriptor.get() || target[key];
        if (oldFn) {
            if (!FunctionCollectionUtil_1.default.is(oldFn)) {
                fnCollection = FunctionCollectionUtil_1.default.create(fn);
                fnCollection.append(oldFn);
            }
            else {
                fnCollection = oldFn;
                fnCollection.prepend(fn);
            }
        }
        else {
            fnCollection = FunctionCollectionUtil_1.default.create(fn);
        }
        descriptorTemplate.get = function () {
            return fnCollection.bind(this);
        };
        descriptorTemplate.set = function (fn) {
            if ('function' !== typeof fn) {
                return console.error(`[Rua][FunctionCollectionDecoratorBuildUtil]:the value
             passed to property '${key}' should be function`);
            }
            fnCollection.append(fn);
        };
        return descriptorTemplate;
    }
}
exports.default = FunctionCollectionDescriptorBuildUtil;
//# sourceMappingURL=FunctionCollectionDescriptorBuildUtil.js.map