"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class FunctionCollectionUtil {
    static is(object) {
        return object.__functionCollectionUtil;
    }
    static create(initialFn) {
        const functionCollection = {
            fnList: [],
            append(fn) {
                functionCollection.fnList.push(fn);
                return this;
            },
            prepend(fn) {
                functionCollection.fnList.unshift(fn);
                return this;
            },
            invoke() {
                return this();
            },
            __functionCollectionUtil: true,
        };
        if (initialFn) {
            functionCollection.append(initialFn);
        }
        const callableFunction = function functionCollection(...args) {
            functionCollection.fnList.forEach(fn => fn.apply(this, args));
        };
        return Object.assign(callableFunction, functionCollection);
    }
}
exports.default = FunctionCollectionUtil;
//# sourceMappingURL=FunctionCollectionUtil.js.map