"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const _toString = Object.prototype.toString;
function ensure(value, fixValue) {
    return value ? value : fixValue;
}
exports.ensure = ensure;
function ensureObject(value, fixValue = {}) {
    const type = typeof value;
    return null !== value && ('object' === type || 'function' === type)
        ? value
        : fixValue;
}
exports.ensureObject = ensureObject;
function ensureObjectLike(value, fixValue = {}) {
    return _.isObjectLike(value) ? value : fixValue;
}
exports.ensureObjectLike = ensureObjectLike;
function ensurePlainObject(value, fixValue = {}) {
    return '[object Object]' === _toString.call(value) ? value : fixValue;
}
exports.ensurePlainObject = ensurePlainObject;
function ensureArray(value, fixValue = []) {
    return Array.isArray(value) ? value : fixValue;
}
exports.ensureArray = ensureArray;
function ensureArrayLike(value, fixValue = []) {
    return _.isArrayLike(value) ? value : fixValue;
}
exports.ensureArrayLike = ensureArrayLike;
function ensureBoolean(value, fixValue) {
    if (true === value || false === value) {
        return value;
    }
    return fixValue !== undefined
        ? fixValue
        : !!value;
}
exports.ensureBoolean = ensureBoolean;
function ensureSymbol(value, fixValue = Symbol()) {
    return 'symbol' === typeof value
        ? value
        : fixValue;
}
exports.ensureSymbol = ensureSymbol;
function ensureInteger(value, fixValue) {
    return Number.isInteger(value)
        ? value
        : fixValue;
}
exports.ensureInteger = ensureInteger;
function ensureNumber(value, fixValue) {
    return 'number' === typeof value || '[object Object]' === _toString.call(value)
        ? value
        : fixValue;
}
exports.ensureNumber = ensureNumber;
//# sourceMappingURL=ensure.js.map