"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Rules {
    constructor(validationString) {
        this.rules = [];
        this.parseFromString(validationString);
    }
    all() {
        return this.rules;
    }
    parseFromString(validationString) {
        const formattedString = validationString.replace(/\s/g, '');
        const rulesStringArray = formattedString.split('|');
        for (const rule of rulesStringArray) {
            const [ruleName, stringArgs] = rule.split(':');
            const ruleArgs = stringArgs
                ? stringArgs.split(',')
                : [];
            this.rules.push({
                name: ruleName,
                args: ruleArgs,
            });
        }
    }
}
exports.default = Rules;
//# sourceMappingURL=Rules.js.map