import DataConvertorEngine from './DataConvertorEngine';
import RuleValidationEngine from './RuleValidationEngine';
import { StringRules, ValidatorConfiguration } from '../type';
import { ValidatorEngineInterface } from '../interface';
import { AnyObject } from '../../core/type/data';
import { CanConfig } from '../../core/type/contract';
declare class ValidatorEngine implements ValidatorEngineInterface, CanConfig {
    failedRules: string[];
    failedMessages: string[];
    unregisteredRules: string[];
    hasUnregisteredRule: boolean;
    protected ruleValidator: RuleValidationEngine;
    protected dataTranslator: DataConvertorEngine;
    protected rules: StringRules;
    protected data: AnyObject;
    protected isValid: boolean;
    protected isFixed: boolean;
    constructor(config: ValidatorConfiguration);
    config(config: ValidatorConfiguration): void;
    validate(): void;
    fails(): boolean;
    passes(): boolean;
}
export default ValidatorEngine;
